class Station{
  float stationX, stationY, stationZ;
  int nTripsTo, nTripsFrom, nTripsTot;
  int sNumber;
  String sName;
  boolean isMetro;
  float hue, sat, bri;
  int degree;
  float bcuw;
  
  Station(int sNumber) {  
    TableRow sRow = stationTable.findRow(str(sNumber),"station_number");
    TableRow yRow = yTable.findRow(str(sNumber),"station_number");
    TableRow lRow = sLocTable.findRow(str(sNumber),"station_number");
    this.sNumber = sNumber;
    this.sName = sRow.getString("station");
    this.nTripsTot = sRow.getInt("totalRides");
    this.isMetro = false;
    this.degree = yRow.getInt("degree");   // degree of connectivity
    this.bcuw = yRow.getFloat("bc_uw");    // unweighted betweenness centrality
    this.sat = 0;
    this.hue = 0;
    this.bri = map(log(nTripsTot),0,10.5,10,65);
    if (this.bri==0) this.bri = 10;
    this.stationX = lRow.getFloat("x_value")*dist;
    this.stationY = -1*degree*ht;
    this.stationZ = lRow.getFloat("y_value")*dist;

  }
  
  void drawStation() {
    
    // put coordinates to station location
    pushMatrix();
    translate(stationX,stationY,stationZ);
        
    stroke(hue,sat,bri);
    strokeWeight(10);
    point(0,0,0);
      
   //  mouseover?
    float mouseDistance = sq(mouseX-screenX(0, 0, 0))+sq(mouseY-screenY(0, 0, 0)); 
    if (mouseDistance < sq(8))  // if mouse over station
    {
      if (mSwitch) {            // add line with station name to display text
        theTxt = theTxt + sName + '\n';
        dispTxt = true;
      }
      if (hSwitch) {            // add station to list of stations to highlight
        mStations.add(this);
      }
    }
    
    // finish draw of station
    popMatrix();
  } 
  
  void setStationLoc(float sX, float sY, float sZ) {
    // sets new station location
    this.stationX = sX;
    this.stationY = sY;
    this.stationZ = sZ;
  }

}