Table newTable;

// given a 1D array, returns maximum value in array
float max1D(float[] array1D) {
  float max = 0;
  for (int i=0; i < array1D.length; i++ ) {
      if (array1D[i]>max) {
        max = array1D[i];
      }
  }
  return max;
}

// given a 1D array, returns minimum value in array
float min1D(float[] array1D) {
  float min = max1D(array1D);        // calls max2D
  for (int i=0; i < array1D.length; i++ ) {
      if (array1D[i]<min) {
        min = array1D[i];
      }
  }
  return min;
}


// given a 2D array, returns maximum value in array
float max2D(float[][] array2D) {
  float max = 0;
  for (int i =0; i < array2D.length; i++ ) {
    for ( int j =0; j < array2D[i].length; j++) {
      if (array2D[i][j]>max) {
        max = array2D[i][j];
      }
    }
  }
  return max;
}

// given a 2D array, returns minimum value in array
float min2D(float[][] array2D) {
  float min = max2D(array2D);        // calls max2D
  for (int i =0; i < array2D.length; i++ ) {
    for ( int j =0; j < array2D[i].length; j++) {
      if (array2D[i][j]<min) {
        min = array2D[i][j];
      }
    }
  }
  return min;
}

void updateStationLoc(boolean dSwitch) {
  // update all station locations based on "degree/centrality" switch
  if (dSwitch==true) {
    ht = 3; // scale
    // set locations to degrees
    for (int s=0; s<nStations; s++) {
      Station sSta = Stations.get(s);
      float theY = -1*sSta.degree*ht;
      sSta.setStationLoc(sSta.stationX,theY,sSta.stationZ);
    }
  }
  else if (dSwitch==false) {
    ht = 90000; // scale
    // set locations to bcentrality
    for (int s=0; s<nStations; s++) {
      Station sSta = Stations.get(s);
      float theY = -1*sSta.bcuw*ht;
      sSta.setStationLoc(sSta.stationX,theY,sSta.stationZ);
    }
  }
}

void updateRouteVis(boolean vSwitch) {
  // updates all route visibilities based on vSwitch
  for (int r=0; r<Routes.size(); r++) {
    Routes.get(r).setVis(vSwitch);
  }
}

void saveStationScale() {
  // performs calculation of total nTrips per stations...
  stationTable.addColumn("totalRides");
  for (int s=0;s<Stations.size();s++) {
    TableRow row = stationTable.findRow(str(Stations.get(s).sNumber),"station_number");
    row.setInt("totalRides",Stations.get(s).nTripsTo+Stations.get(s).nTripsFrom);
  }
  saveTable(stationTable,"test.csv");
}